#include "stm32f10x.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define    rs   GPIO_Pin_1
#define    en   GPIO_Pin_2
#define    PORT_LCD   GPIOA
#define    DATA_4   GPIO_Pin_3
#define    DATA_5   GPIO_Pin_4
#define    DATA_6   GPIO_Pin_5
#define    DATA_7   GPIO_Pin_6

#define CLRSCR 0x01
#define DISPLAY_ON 0x0C
#define DISPLAY_OFF 0x08
#define CURSOR_ON 0x0A
#define CURSOR_OFF 0x08
#define CURSOR_INC 0x06
#define MODE_8BIT 0x38
#define MODE_4BIT 0x28

#define LCD_LINE1 0x80
#define LCD_LINE2 0xC0
#define LCD_LINE3 0x94
#define LCD_LINE4 0xD4
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

void LCD_COM(u8 COM);
void LCD_DATA(u8 DATA);
void  cls(void);
void  RESET_LCD(void);




//******************************************************************************************
void LCD_COM(u8 COM){
  /*
  output_low(RS);

output_high(en);
delay_cycles(1);
output_low(en);
  */
   GPIO_ResetBits(PORT_LCD, rs);  
   GPIO_WriteBit (PORT_LCD,DATA_4,(BitAction)(COM&0x10)); 
   GPIO_WriteBit (PORT_LCD,DATA_5,(BitAction)(COM&0x20)); 
   GPIO_WriteBit (PORT_LCD,DATA_6,(BitAction)(COM&0x40)); 
   GPIO_WriteBit (PORT_LCD,DATA_7,(BitAction)(COM&0x80)); 
   GPIO_SetBits(GPIOA, en);
   delay_ms(1);
   GPIO_ResetBits(PORT_LCD, en);
   GPIO_WriteBit (PORT_LCD,DATA_4,(BitAction)(COM&0x01)); 
   GPIO_WriteBit (PORT_LCD,DATA_5,(BitAction)(COM&0x02)); 
   GPIO_WriteBit (PORT_LCD,DATA_6,(BitAction)(COM&0x04)); 
   GPIO_WriteBit (PORT_LCD,DATA_7,(BitAction)(COM&0x08)); 
   GPIO_SetBits(PORT_LCD, en);
   delay_ms(1);
   GPIO_ResetBits(GPIOA, en);

  
}
//******************************************************************************************
void LCD_DATA(u8 DATA){
  
   GPIO_SetBits(PORT_LCD, rs);  
   GPIO_WriteBit (PORT_LCD,DATA_4,(BitAction)(DATA&0x10)); 
   GPIO_WriteBit (PORT_LCD,DATA_5,(BitAction)(DATA&0x20)); 
   GPIO_WriteBit (PORT_LCD,DATA_6,(BitAction)(DATA&0x40)); 
   GPIO_WriteBit (PORT_LCD,DATA_7,(BitAction)(DATA&0x80)); 
   GPIO_SetBits(PORT_LCD, en);
   delay_ms(1);
   GPIO_ResetBits(PORT_LCD, en);
   GPIO_WriteBit (PORT_LCD,DATA_4,(BitAction)(DATA&0x01)); 
   GPIO_WriteBit (PORT_LCD,DATA_5,(BitAction)(DATA&0x02)); 
   GPIO_WriteBit (PORT_LCD,DATA_6,(BitAction)(DATA&0x04)); 
   GPIO_WriteBit (PORT_LCD,DATA_7,(BitAction)(DATA&0x08)); 
   GPIO_SetBits(PORT_LCD, en);
   delay_ms(1);
   GPIO_ResetBits(PORT_LCD, en); 
}


//******************************************************************************************

void  cls(void){
u8 g[6]={0x28,0x0e,0x01,0x02,0x0C,0x80},i;
RESET_LCD();
for(i=0;i<6;i++){
delay_ms(1);
LCD_COM(g[i]);
}

}


//*********************************************************************************************
void  RESET_LCD(void){
  
delay_init(24);
delay_ms(500);
LCD_COM(0x03);
delay_us(500);
LCD_COM(0x03);
delay_us(500);
LCD_COM(0x03);
delay_us(500);
LCD_COM(2);
delay_us(500);
  
}









